var gestion_mapa = {

	mapa : '',

	arrPuntos : [],

	getLocalidad : function (lat, lon, callback) {
        var geocoder = new google.maps.Geocoder();
        
        geocoder.geocode({'latLng' : new google.maps.LatLng(lat, lon)}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                var localidad = gestion_mapa.getAddressComponent(results, 'locality');
                callback(localidad);
            }
        });
    },
    getAddressComponent: function(address, component) {
        var components = address[0]['address_components'];
         
        for (var i in components) {
        	if(components[i]['types'].indexOf(component)>-1) {
        		return components[i]['long_name'];
        	}
        }
        return false;
    },
	crear_mapa : function() {
		var localidad = $("#cp_poblacion").val();

		if(localidad != "") {
			$.ajax({
                url: "obtener-puntos.php",
                //url: "http://localhost/City4All/es/enviar-resultados.php",
                data: { ubicacion : localidad },
                //type : 'GET',
                jsonp: "callback",
                dataType: "jsonp",
                success: function(puntos) {
                	gestion_mapa.mapa = new google.maps.Map(document.getElementById('mapa_img'),{
						center: new google.maps.LatLng(puntos[0]['latitud'], puntos[0]['longitud']),
			        	//center: {lat: pos.coords.latitude, lng: pos.coords.longitude},
			        	scrollwheel: false,
			        	zoom: 15
		   			});

					var mapBounds = new google.maps.LatLngBounds();

                    for(var i in puntos) {

                       	gestion_mapa.arrPuntos[i] = puntos[i];
                       	var latLng = new google.maps.LatLng(puntos[i]['latitud'], puntos[i]['longitud']);

                        if(puntos[i]['codigo'] < 3) {
                            gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
                                position: latLng, 
                                map: gestion_mapa.mapa,
                                icon: "http://maps.google.com/mapfiles/ms/icons/red-dot.png",
                                draggable: false
                            });  
                        } else if (puntos[i]['codigo'] == 3) {
                           gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
                                position: latLng, 
                                map: gestion_mapa.mapa,
                                icon: "http://maps.google.com/mapfiles/ms/icons/yellow-dot.png",
                                draggable: false
                            });  
                        } else {
                            gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
                                position: latLng, 
                                map: gestion_mapa.mapa,
                                icon: "http://maps.google.com/mapfiles/ms/icons/green-dot.png",
                                draggable: false
                            }); 
                        }
                        mapBounds.extend(latLng); 
                    }
                    gestion_mapa.mapa.fitBounds(mapBounds);

                    gestion_mapa.filtrar_login();

                },
                error: function(xhr, status, text) {
                    //alert(text);
                }
            })
		} else {
			navigator.geolocation.getCurrentPosition(function(pos) {
				gestion_mapa.mapa = new google.maps.Map(document.getElementById('mapa_img'),{
		        	center: {lat: pos.coords.latitude, lng: pos.coords.longitude},
		        	scrollwheel: false,
		        	zoom: 15
		   		});

		   		var mapBounds = new google.maps.LatLngBounds();

				gestion_mapa.getLocalidad(pos.coords.latitude,pos.coords.longitude,function(localidad) {

					$.ajax({
	                    url: "obtener-puntos.php",
	                    //url: "http://localhost/City4All/es/enviar-resultados.php",
	                    data: { ubicacion : localidad },
	                    //type : 'GET',
	                    jsonp: "callback",
	                    dataType: "jsonp",
	                    success: function(puntos) {
		                    for(var i in puntos) {
		                       	gestion_mapa.arrPuntos[i] = puntos[i];
		                       	var latLng = new google.maps.LatLng(puntos[i]['latitud'], puntos[i]['longitud']);

		                        if(puntos[i]['codigo'] < 3) {
		                            gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
		                                position: latLng, 
		                                map: gestion_mapa.mapa,
		                                icon: "http://maps.google.com/mapfiles/ms/icons/red-dot.png",
		                                draggable: false
		                            });  
		                        } else if (puntos[i]['codigo'] == 3) {
		                           gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
		                                position: latLng, 
		                                map: gestion_mapa.mapa,
		                                icon: "http://maps.google.com/mapfiles/ms/icons/yellow-dot.png",
		                                draggable: false
		                            });  
		                        } else {
		                            gestion_mapa.arrPuntos[i]['marker'] = new google.maps.Marker({
		                                position: latLng, 
		                                map: gestion_mapa.mapa,
		                                icon: "http://maps.google.com/mapfiles/ms/icons/green-dot.png",
		                                draggable: false
		                            }); 
		                        }
		                        mapBounds.extend(latLng); 
		                    }
		                    gestion_mapa.mapa.fitBounds(mapBounds);

		                    gestion_mapa.filtrar_login();
	                    },
	                    error: function(xhr, status, text) {
	                        //alert(text);
	                    }
	                })
				});
        	});
		}
	},
	filtrar : function() {
		var experiencia = $("#experiencia").val();
		var edad = $("#edad").val();
		var meses = $("#tiempo").val();
		var hoy = new Date();

		for(var i in gestion_mapa.arrPuntos) {
			var visible = true;
			
			if(experiencia == "seguras" && gestion_mapa.arrPuntos[i]['codigo'] <= 3) {
				visible = false;
			} 
			else if(experiencia == "neutras" && gestion_mapa.arrPuntos[i]['codigo'] != 3) {
				visible = false;
			}
			else if(experiencia == "inseguras" && gestion_mapa.arrPuntos[i]['codigo'] > 2) {
				visible = false;
			}
			
			if(edad == "18" && gestion_mapa.arrPuntos[i]['edad'] > 25) {
				visible = false;
			} 
			else if(edad == "26" && (gestion_mapa.arrPuntos[i]['edad'] < 26 || gestion_mapa.arrPuntos[i]['edad'] > 65)) {
				visible = false;
			} 
			else if(edad == "65" && gestion_mapa.arrPuntos[i]['edad'] < 66) {
				visible = false;
			}

			gestion_mapa.arrPuntos[i]['marker'].setVisible(visible);		
		}
	},
	// Función para calcular los días transcurridos entre dos fechas
	restaFechas : function(f1,f2)
	{
	 	var aFecha1 = f1.split('-'); 
	 	var aFecha2 = f2.split('-'); 
	 	var fFecha1 = Date.UTC(aFecha1[0],aFecha1[1]-1,aFecha1[2]); 
	 	var fFecha2 = Date.UTC(aFecha2[0],aFecha2[1]-1,aFecha2[2]); 
	 	var dif = fFecha2 - fFecha1;
	 	var dias = Math.floor(dif / (1000 * 60 * 60 * 24)); 
	 	return dias;
	},
	filtrar_login : function() {
		var experiencia = $("#experiencia").val();
		var edad = $("#edad").val();
		var meses = $("#tiempo").val();
		var sexo = $("#sexo").val();
		var dia = $("#dia").val();
		var hora = $("#hora").val();

		var hoy = new Date();

		for(var i in gestion_mapa.arrPuntos) {
			var visible = true;
			
			if(experiencia == "seguras" && gestion_mapa.arrPuntos[i]['codigo'] <= 3) {
				visible = false;
			} 
			else if(experiencia == "neutras" && gestion_mapa.arrPuntos[i]['codigo'] != 3) {
				visible = false;
			}
			else if(experiencia == "inseguras" && gestion_mapa.arrPuntos[i]['codigo'] > 2) {
				visible = false;
			}
			
			if(edad == "18" && gestion_mapa.arrPuntos[i]['edad'] > 25) {
				visible = false;
			} 
			else if(edad == "26" && (gestion_mapa.arrPuntos[i]['edad'] < 26 || gestion_mapa.arrPuntos[i]['edad'] > 65)) {
				visible = false;
			} 
			else if(edad == "65" && gestion_mapa.arrPuntos[i]['edad'] < 66) {
				visible = false;
			}

			var fecha_cuestionario = gestion_mapa.arrPuntos[i]['fecha_hora'].split(' ');
			var hora_cuestionario = fecha_cuestionario[1];
			fecha_cuestionario = fecha_cuestionario[0];
			var fecha_cuestionario_aux = fecha_cuestionario.split('-');

			var Fecha = new Date();
			var fecha_hoy = Fecha.getFullYear() + "-" + (Fecha.getMonth() +1) + "-" + Fecha.getDate();

			var dias = gestion_mapa.restaFechas(fecha_cuestionario, fecha_hoy);

			if(meses == "12" && dias > 365) {
				visible = false;
			} else if(meses == "6" && dias > 180) {
				visible = false;
			} else if(meses == "3" && dias > 90) {
				visible = false;
			}

			var Fecha_cuestionario_Date = new Date(fecha_cuestionario_aux[0], fecha_cuestionario_aux[1]-1, fecha_cuestionario_aux[2]);
			var dia_semana = Fecha_cuestionario_Date.getDay();

			if(dia == "entre-semana" && (dia_semana == 0 || dia_semana == 6)) {
				visible = false;
			} else if(dia == "fin-semana" && dia_semana > 0 && dia_semana < 6) {
				visible = false;
			}

			if(sexo == "hombre" && gestion_mapa.arrPuntos[i]['sexo'] == 1) {
				visible = false;
			} else if(sexo == "mujer" && gestion_mapa.arrPuntos[i]['sexo'] == 2) {
				visible = false;
			}

			hora_cuestionario = hora_cuestionario.split(':');
			hora_cuestionario = hora_cuestionario[0];

			if(hora == "manana" && (hora_cuestionario < 7 || hora_cuestionario > 13)) {
				visible = false;
			} else if(hora == "tarde" && (hora_cuestionario < 14 || hora_cuestionario > 21)) {
				visible = false;
			} else if(hora == "noche" && hora_cuestionario < 22 && hora_cuestionario > 6) {
				visible = false;
			}

			gestion_mapa.arrPuntos[i]['marker'].setVisible(visible);			
		}
	},
}

google.maps.event.addDomListener(window, 'load', gestion_mapa.crear_mapa);